// OptionBangs.cpp : implementation file
//

#include "stdafx.h"
#include "base.h"
#include "OptionBangs.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

DWORD  __stdcall EnumerateBangs(void *param);

/////////////////////////////////////////////////////////////////////////////
// COptionBangs dialog

COptionBangs::COptionBangs(CWnd* pParent): CDialog(COptionBangs::IDD, pParent)
{
	//{{AFX_DATA_INIT(COptionBangs)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void COptionBangs::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(COptionBangs)
	DDX_Control(pDX, IDC_PARAMS, m_wndParams);
	DDX_Control(pDX, IDC_LISTBANGS, m_wndListbangs);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(COptionBangs, CDialog)
	//{{AFX_MSG_MAP(COptionBangs)
	ON_BN_CLICKED(IDC_EXECBANG, OnExecbang)
	ON_BN_CLICKED(IDC_REFRESH, OnRefresh)
	ON_WM_SHOWWINDOW()
	ON_WM_COPYDATA()
	ON_LBN_DBLCLK(IDC_LISTBANGS, OnDoubleClickListBangs)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COptionBangs message handlers

void COptionBangs::LoadText()
{
	m_wndListbangs.ResetContent();

	if (!settingsipc_client::IsServerPresent())
	{
		m_wndListbangs.AddString("SettingsIPC module is not loaded.");
		m_wndListbangs.AddString("Please check your configuration.");
	}
	else
	{
		// EnumLSData must be called in a new thread since it operates with
		// Windows message queue and LoadText can be called from MessageProc too...
		DWORD thId;
		CreateThread(NULL, 0, EnumerateBangs, this, 0, &thId);
	}
}

void COptionBangs::OnExecbang() 
{
	int nSelection = m_wndListbangs.GetCurSel();
	if (nSelection !=LB_ERR)
	{
		CString szSelection;
		CString parameter;

		m_wndListbangs.GetText(nSelection, szSelection);
		m_wndParams.GetWindowText(parameter);

		utils.ExecuteBang(szSelection + " " + parameter);
	}
}

void COptionBangs::OnRefresh() 
{
	LoadText();
}

void COptionBangs::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	CDialog::OnShowWindow(bShow, nStatus);
	
	if (bShow) LoadText();
}

void COptionBangs::OnDoubleClickListBangs() 
{
	OnExecbang();
}

BOOL COptionBangs::OnCopyData(CWnd* pWnd, COPYDATASTRUCT* pCopyDataStruct) 
{
	int count = * ((int*) pCopyDataStruct->lpData );
	EnumLSDataInfo *info = (EnumLSDataInfo*)((char*)pCopyDataStruct->lpData + sizeof(int));
	for (int i = 0; i < count; i++)
	{
		m_wndListbangs.AddString(info[i].szString);
	}		
	return CDialog::OnCopyData(pWnd, pCopyDataStruct);
}

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//
// Separate thread for EnumLSData :)
//
DWORD  __stdcall EnumerateBangs(void *param)
{
	COptionBangs *option = (COptionBangs*)param;
	HRESULT hr = settingsipc_client::EnumLSData(ELD_BANGS, option->m_hWnd);
	if (FAILED(hr))
	{
		option->m_wndListbangs.AddString("Unknown error raised during bangs list processing");
	}
	return 0;
}

