// OptionInstaller.cpp : implementation file
//

#include "stdafx.h"
#include "base.h"
#include "OptionInstaller.h"
#include "utils.h"
#include "ThemeInstaller.h"
#include "InstallerConfig.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

UINT DownloadFile(LPVOID pParam);

/////////////////////////////////////////////////////////////////////////////
// COptionInstaller dialog


COptionInstaller::COptionInstaller(CWnd* pParent /*=NULL*/)
	: CDialog(COptionInstaller::IDD, pParent)
{
	bTerminate = true;
	//{{AFX_DATA_INIT(COptionInstaller)
	m_bDoNotSwitch = FALSE;
	//}}AFX_DATA_INIT
}


void COptionInstaller::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(COptionInstaller)
	DDX_Control(pDX, IDC_THEMEFILE, m_editThemeFile);
	DDX_Control(pDX, IDC_LISTLOG, m_Log);
	DDX_Control(pDX, IDC_DLPROGRESS, m_Progress);
	DDX_Check(pDX, IDC_DONOTSWITCH, m_bDoNotSwitch);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(COptionInstaller, CDialog)
	//{{AFX_MSG_MAP(COptionInstaller)
	ON_BN_CLICKED(IDC_SELECTFILE, OnSelectFile)
	ON_BN_CLICKED(IDC_INSTALLTHEME, OnInstallTheme)
	ON_BN_CLICKED(IDC_INSTALLEROPTIONS, OnInstallerOptions)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COptionInstaller message handlers

BOOL COptionInstaller::OnInitDialog() 
{
	CDialog::OnInitDialog();
	return TRUE;
}

void COptionInstaller::OnSelectFile() 
{
	CString filt = "Theme archive files (*.zip;*.lsz)|*.zip;*.lsz|";
	CFileDialog fileDlg(TRUE,"*.zip;*.lsz","*.zip;*.lsz",NULL,filt,this);
	if (utils.bIsNT50)
	{
		fileDlg.m_ofn.lStructSize = sizeof(OPENFILENAMEEX);
	}
	fileDlg.m_ofn.Flags |= OFN_FILEMUSTEXIST;
	fileDlg.m_ofn.lpstrTitle = "Select a theme archive:";
	
	if (fileDlg.DoModal() == IDOK) 
	{
		CWaitCursor bob;
		SetDlgItemText(IDC_THEMEFILE,fileDlg.GetPathName());
	}	
}

void COptionInstaller::OnInstallTheme() 
{
	CButton* bGetFile = (CButton*)GetDlgItem(IDC_INSTALLTHEME);
	CString btnlabel;
	GetDlgItemText(IDC_INSTALLTHEME,btnlabel);
	if (btnlabel == "Cancel")
	{
		bTerminate = true; // Direct to our thread to terminate
		// Reset GUI interface
		SetDlgItemText(IDC_FS,"Downloaded : ");
		SetWindowText("File Downloader");
		SetDlgItemText(IDC_PERC,"0%");
		SetDlgItemText(IDC_KBSEC,"0kb/sec");
		m_Progress.SetPos(0);
		SetDlgItemText(IDC_INSTALLTHEME,"&Install theme");
		m_editThemeFile.EnableWindow(TRUE);
	}
	else
	{
		CString szFile, szProto;
		GetDlgItemText(IDC_THEMEFILE,szFile); // Get the file name from editbox
		if (szFile.Find('/') < 0) // it is a local file name - just install it
		{
			bGetFile->SetWindowText("Cancel");
			m_editThemeFile.EnableWindow(FALSE);
			utils.Trim(szFile);
			if (themeinstaller.Install(szFile, m_Log, IsDlgButtonChecked(IDC_DONOTSWITCH) != FALSE))
				m_Log.AddString("Theme installed successfully");
			else
				m_Log.AddString("Theme installation failed");
			m_Log.AddString("");
			bGetFile->SetWindowText("&Install theme");
			m_editThemeFile.EnableWindow(TRUE);
		} else	// URL contain slash (/), so we need to download the file first...
		{
			bGetFile->SetWindowText("Cancel");
			m_editThemeFile.EnableWindow(FALSE);
			bTerminate = false;
			CWinThread* pThread = AfxBeginThread(DownloadFile, this, THREAD_PRIORITY_NORMAL);
		}
	}
}


void COptionInstaller::OnInstallerOptions()
{
	CInstallerConfig confdlg(this);
	confdlg.DoModal();
}
