// OptionTheme.cpp : implementation file
//

#include "stdafx.h"
#include "base.h"
#include "OptionTheme.h"
#include "ThemeInstaller.h"
#include "RecoveryMenu.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// COptionTheme dialog

COptionTheme::COptionTheme(CWnd* pParent): CDialog(COptionTheme::IDD, pParent)
{
	//{{AFX_DATA_INIT(COptionTheme)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

void COptionTheme::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(COptionTheme)
	DDX_Control(pDX, IDC_OTSLIST1, m_wndThemesList);
	DDX_Control(pDX, IDC_IOTSNFOIMAGE, m_wndInfoimage);
	DDX_Control(pDX, IDC_THEMEINFO, m_wndListThemeInfo);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(COptionTheme, CDialog)
	//{{AFX_MSG_MAP(COptionTheme)
	ON_BN_CLICKED(IDC_OTSSWITCH, OnSwitch)
	ON_BN_CLICKED(IDC_OTSREADME, OnReadme)
	ON_LBN_DBLCLK(IDC_OTSLIST1, OnDblclkList1)
	ON_LBN_SELCHANGE(IDC_OTSLIST1, OnSelchangeList1)
	ON_WM_PAINT()
	ON_BN_CLICKED(IDC_OTSREFRESH, OnRefresh)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COptionTheme message handlers
BOOL COptionTheme::OnInitDialog() 
{
	CDialog::OnInitDialog();
	m_wndListThemeInfo.SetExtendedStyle( LVS_EX_FULLROWSELECT );
	m_wndListThemeInfo.SetHeadings("Setting,80;Value,137");
	LoadThemes();
	if (!utils.CheckLSRunning())
	{
		CRecoveryMenu dlg;
		dlg.DoModal();
		switch(dlg.retv)
		{
		case MODE_DEFAULTTHEME:
			themeinstaller.Switch(themeinstaller.szDefaultTheme);
		case MODE_STARTLITESTEP:
			utils.ExecuteBang("");
			break;
		case MODE_LSCPONLY:
			break;
		default:
			AfxMessageBox("Ugly...");
		}
	}
	return TRUE;
}

//load the available themes from themes dir
void COptionTheme::LoadThemes()
{
	m_wndThemesList.ResetContent();
	//search projects directory and list projects
	HANDLE hFind;
	WIN32_FIND_DATA dataFind;
	BOOL bMoreFiles = TRUE;

	//find first file in the themes directory
	hFind = FindFirstFile(utils.themesDir + "*.*", &dataFind);

	while (hFind != INVALID_HANDLE_VALUE && bMoreFiles == TRUE)
	{		
		if(dataFind.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY || ( dataFind.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY && dataFind.dwFileAttributes & FILE_ATTRIBUTE_ARCHIVE ) )
		{
			if (strcmp(dataFind.cFileName, ".") && strcmp(dataFind.cFileName, ".."))
			{
				m_wndThemesList.AddString(dataFind.cFileName);
			}
		}
		bMoreFiles = FindNextFile(hFind, &dataFind);
	}
	FindClose(hFind);

	if (m_wndThemesList.GetCount() == 0)
	{
		m_wndThemesList.AddString("Are you sure you have an OTS distro?");
	}
}

//switch theme
void COptionTheme::OnSwitch() 
{
	OnDblclkList1();
}


//refresh the list etc.
void COptionTheme::OnRefresh() 
{
	LoadThemes();
}

//show the theme readme
void COptionTheme::OnReadme() 
{
	int nSelection = m_wndThemesList.GetCurSel();
	if (nSelection !=LB_ERR)
	{
		HINSTANCE hinst;
		CString szSelection;
		m_wndThemesList.GetText(nSelection, szSelection);

		CString infopath = utils.themesDir + szSelection + "\\";

		hinst = ::ShellExecute(m_hWnd, "open", infopath + "readme.htm", NULL, NULL, SW_SHOWNORMAL);
		if (hinst >= (HINSTANCE)HINSTANCE_ERROR) return;
		hinst = ::ShellExecute(m_hWnd, "open", infopath + "readme.chm", NULL, NULL, SW_SHOWNORMAL);
		if (hinst >= (HINSTANCE)HINSTANCE_ERROR) return;
		hinst = ::ShellExecute(m_hWnd, "open", infopath + "readme.txt", NULL, NULL, SW_SHOWNORMAL);
		if (hinst < (HINSTANCE)HINSTANCE_ERROR)
		{
			AfxMessageBox("The Readme file is not available.");
		}
	}
}		

//switch theme
void COptionTheme::OnDblclkList1() 
{
	int nSelection = m_wndThemesList.GetCurSel();

	if (nSelection !=LB_ERR)
	{
		CString szSelection;
		m_wndThemesList.GetText(nSelection, szSelection);

		CString szMessage = "Selected theme: " + szSelection + "\nSwitch to the selected theme?";
		int nChoice = AfxMessageBox(szMessage, MB_YESNO | MB_ICONQUESTION);
		if (nChoice == IDYES)
		{
			themeinstaller.Switch(szSelection);
		}
	}
}

//on selchange load the preview image
void COptionTheme::OnSelchangeList1() 
{
	int nSelection = m_wndThemesList.GetCurSel();

	if (nSelection !=LB_ERR)
	{
		CString szSelection;
		m_wndThemesList.GetText(nSelection, szSelection);

		//let's try to load the preview image
		//most OTS2 themers are lazy and don't include previews,
		//but it doesn't mean that we must exclude this feature :)

		CEnBitmap bitmap;

		if ((bitmap.LoadImage(utils.themesDir + szSelection + "\\preview.jpg"))
		||  (bitmap.LoadImage(utils.themesDir + szSelection + "\\preview.bmp"))
		||  (bitmap.LoadImage(utils.themesDir + szSelection + "\\preview.gif"))
		||  (bitmap.LoadImage(utils.themesDir + szSelection + "\\misc\\preview.jpg"))
		||  (bitmap.LoadImage(utils.themesDir + szSelection + "\\misc\\preview.bmp"))
		||  (bitmap.LoadImage(utils.themesDir + szSelection + "\\misc\\preview.gif")))
		{
			m_wndInfoimage.ShowWindow(false);
			m_bitmap.DeleteObject();
			m_bitmap.Attach(bitmap.Detach());
			CDC *dc = GetDC();
			DrawPreview(*dc);
			ReleaseDC(dc);
		}
		else
		{
			m_wndInfoimage.ShowWindow(true);
		}
		
		// gather and show theme information
		m_wndListThemeInfo.DeleteAllItems();

		CString themerc = utils.GetFullThemeRCName(szSelection);
		bool isots1 = utils.IsThemeOTS1Compliant(szSelection);
		CString szOTSVersion;
		if (isots1)
		{
			szOTSVersion = "1.0 or non-OTS";
		}
		else
		{
			szOTSVersion =
				utils.ReadOptionFromRC(themerc,"OTSMajorVersion") + "." +
				utils.ReadOptionFromRC(themerc,"OTSMinorVersion");
		}
		m_wndListThemeInfo.AddItem("OTS Version",szOTSVersion);
		m_wndListThemeInfo.AddItem("Theme Name",
			utils.ReadOptionFromRC(themerc,"ThemeName"));
		m_wndListThemeInfo.AddItem("Theme Author",
			utils.ReadOptionFromRC(themerc,"ThemeAuthor"));
		if (!isots1)
		{
			bool bWall = (utils.ReadOptionFromINI(szSelection,"wallpaper") != "");
			m_wndListThemeInfo.AddItem("Own wallpaper", bWall ? "yes" : "no");
		}
	}
}

//paint the preview image
void COptionTheme::OnPaint() 
{
	CPaintDC dc(this); // device context for painting

	DrawPreview(dc);
}

void COptionTheme::DrawPreview(CDC &dc)
{
	/*
	if (m_bitmap.GetSafeHandle())
	{
		CDC dcMem;
		if (dcMem.CreateCompatibleDC(&dc))
		{
			CDC dcMem2;
			if (dcMem2.CreateCompatibleDC(&dc))
			{
				CBitmap* pOldBM = dcMem2.SelectObject(&m_bitmap);
				BITMAP BM;

				m_bitmap.GetBitmap(&BM);
				dcMem2.StretchBlt(0, 0, 200, 150, &dcMem, 0, 0, BM.bmWidth, BM.bmHeight, SRCCOPY);
				dc.BitBlt(238, 145, 200, 150, &dcMem2, 0, 0, SRCCOPY);
				dcMem2.SelectObject(pOldBM);
			}
		}
	}
	*/
	if (m_bitmap.GetSafeHandle())
	{
		CDC dcMem;
		if (dcMem.CreateCompatibleDC(&dc))
		{
			CBitmap* pOldBM = dcMem.SelectObject(&m_bitmap);
			BITMAP BM;
			m_bitmap.GetBitmap(&BM);
			dc.StretchBlt(238, 145, 200, 150, &dcMem, 0, 0, BM.bmWidth, BM.bmHeight, SRCCOPY );			
			dcMem.SelectObject(pOldBM);
		}
	}
}
