#ifndef __UTILS_HEADER__
#define __UTILS_HEADER__

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "fontinstall.h"

// Utils.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CUtils class

class CUtils
{
	CString GetToolPath();
public:
	CString GetModuleVersion(CString csModule);
	void TakeShutdownPriviledges();
	bool WriteKey(HKEY domain, CString keyname, CString valuename, DWORD value, bool &changed);
	bool WriteKey(HKEY domain, CString keyname, CString valuename, CString value, bool &changed);
	void SetShell(CString shellpath, bool bCurrentUserOnly);
	void Trim(CString &csString);
	void TrimRight(CString &csString);
	void TrimLeft(CString &csString);
	void DeleteFolder(CString csFolder);
	void CopyToClipboard(HWND hWnd, CString csText);
	CString ExpandString(CString pattern);
	CUtils();
	~CUtils();

	bool bIsNT50;
	CString toolDir;
	CString themesDir;
	CString personalDir;
	CString litestepDir;
	CString litestepExe;

	bool DetermineDirs();
	void WriteRegistry();

	void ExecuteBang(CString bang);
	bool CheckLSRunning();
	CString GetLSVersion();

	bool GetShellFolderPath(int nFolder, LPTSTR ptzPath, size_t cchPath);
	HRESULT PathAddBackslashEx(LPTSTR ptzPath, size_t cchPath);

	bool IsThemeOTS1Compliant(CString themename);
	bool SaveBitmapToFile(HBITMAP hBmp, CString pszFileName);
	void InstallWallpaper(CString wallfile, CString walltype);

	CString GetFullThemeRCName(CString themename);
	CString ReadOptionFromINI(CString themename, CString settingname);
	CString ReadOptionFromRC(CString rcfile, CString settingname);
	bool WriteOptionToRC (CString rcfile, CString settingname, CString value);

	void LoadTextFile(CString szFileName, CHListBox &listbox);

	bool IsFileExist(CString szFileName);
};

extern CUtils utils;

#endif
